/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.glassfish.websockets.platform;

import org.glassfish.websockets.api.ContainerContext;
import org.glassfish.websockets.api.WSEndpoint;
/**
 *
 * @author dannycoward
 */
public class ContainerContextImpl extends WithProperties implements ContainerContext {
    static boolean WEB_MODE = true;
    private String wsPath;
    private int port;
    private BeanServer beanServer;
    
    public ContainerContextImpl(BeanServer beanServer, String wsPath, int port) {
        this.wsPath = wsPath;
        this.port = port;
        this.beanServer = beanServer;
    }
    
    public String getPath() {
        return this.wsPath;
    }
    
    public int getPort() {
        return this.port;
    }
    
    public String getProtocol() {
        return "ws";
    }
    
    public void deploy(WSEndpoint endpoint, String path) {
        WebSocketEndpointAdapter adapter = new WebSocketEndpointAdapter(endpoint, path);
        adapter.init();
        this.beanServer.deploy(adapter);
    } 
    
    public static void setWebMode(boolean b) {
        WEB_MODE = b;
    }
    
    
    public String toString() {
        return "ContainerContext("+this.wsPath+")";
    }
}
