/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package org.glassfish.websockets.platform;

import java.util.*;
import org.glassfish.websockets.api.*;
import java.io.IOException;
import javax.servlet.http.*;
/**
 *
 * @author dannycoward
 */
public class ConversationImpl {
    private Set<Peer> remotes = new HashSet<Peer>();
    private org.glassfish.grizzly.websockets.WebSocket socket;
    private Long id;
    private Map properties = new HashMap();
    private boolean isValid = true;
    private HttpSession httpSession;
    
    ConversationImpl(org.glassfish.grizzly.websockets.WebSocket socket, Long id, HttpSession httpSession) {
        this.socket = socket;
        this.id = id;
        this.httpSession = httpSession;
    }
    
    public HttpSession getHttpSession() {
        return this.httpSession;
    }
    
    public boolean isValid() {
        if (!socket.isConnected()) {
            isValid = false;
        }
        return isValid;
    }
    
    public void expire() throws IOException {
        this.socket.close();
        this.properties = new HashMap();
        this.setValid(false);
        
    }
    
    void setValid(boolean isValid) {
        this.isValid = isValid;
    }
    
    public Map getProperties() {
        return this.properties;
    }
    
    public Long getSessionID() {
        return id;
    }
    
    public Set<Peer> getRemotes() {
        return remotes;
    }
    
    public Peer getRemote(Class c) {
        for (Peer nextRemote : remotes) {
            if (nextRemote.getClass().equals(c)) {
                return nextRemote;
            }
            Class[] interfaces = nextRemote.getClass().getInterfaces();
            for (Class ifc : interfaces) {
                if (ifc.equals(c)) {
                    return nextRemote;
                }
            }
            
        }
        return null;
    }
    
    public String toString() {
        return "Session"+id+"("+remotes+";"+this.properties+")";
    }
    
    void addRemote(Peer remote) {
        this.remotes.add(remote);
    }
    org.glassfish.grizzly.websockets.WebSocket getWebSocket() {
        return this.socket;
    }


}
