/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.glassfish.websockets.platform;

import org.glassfish.websockets.api.*;
import java.util.*;
/**
 *
 * @author dannycoward
 */
public class EndpointContextImpl extends WithProperties implements EndpointContext {
    private Set<Conversation> webSocketSessions = new HashSet<Conversation>();
    private ContainerContextImpl containerContext;
    private WebSocketEndpoint application;
    
    @Override
    public String getPath() {
        return this.application.path;
    }
    
    public EndpointContextImpl(ContainerContextImpl containerContext, WebSocketEndpoint application) {
        this.containerContext = containerContext;
        this.application = application;
    }
    
    @Override
    public Set<Conversation> getConversations() {
        this.weedExpiredSessions();
        return this.webSocketSessions;
    }
    
    public ContainerContext getContainerContext() {
        return this.containerContext;
    }
    
    private void weedExpiredSessions() {
        Set<Conversation> expired = new HashSet<Conversation>();
        for (Conversation session : webSocketSessions) {
            if (!session.isActive()) {
                expired.add(session);
            }
        }
        for (Conversation toRemove : expired) {
            webSocketSessions.remove(toRemove);
        }
    }
    
    void addWebSocketSession(WebSocketConversationImpl webSocketSession) {
        webSocketSessions.add(webSocketSession);
    }
    
    public String toXString() {
        return "WebSocketContext(" + this.getPath() + ")";
    }
}
