/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.glassfish.websockets.platform;

import org.glassfish.websockets.api.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
/**
 *
 * @author dannycoward
 */
public class WebSocketConversationImpl extends WithProperties implements Conversation {
    private WebSocketWrapper wsw;
    private long conversationID;
    static long count = 0;
    private HttpSession httpSession;
    
    WebSocketConversationImpl(WebSocketWrapper wsw) {
        this.wsw = wsw;
        this.conversationID = count;
        count++;
    }
    
    void setHttpSession(HttpSession httpSession) {
        this.httpSession = httpSession;
    }
    
    public HttpSession getHttpSession() {
        return this.httpSession;
    }
    
    public String getSubprotocol() {
        return "not implemented";
    }
    
    public Peer getRemote() {
        return wsw;
    }
    
     /** Return a unique ID for this session.*/
    public Long getConversationID() {
        return new Long(count);
    }
    
    public boolean isActive() {
        return wsw.isConnected();
    }
    
    public Date getActivationTime() {
        return this.wsw.activationTime;
    }
    
    /** Closes the underlying connection this session is based upon.*/
    public void deactivate() throws IOException {
        this.wsw.getSocket().close();
    }
    
    public String toString() {
        return "Session("+conversationID+", "+this.isActive()+")"; 
    }
}
