/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.glassfish.websockets.platform;

import org.glassfish.grizzly.http.Cookies;
import org.glassfish.websockets.platform.web.HttpSessionManager;
import org.glassfish.grizzly.websockets.*;
import org.glassfish.grizzly.http.HttpRequestPacket;
import java.io.*;
import javax.servlet.http.*;
import java.util.*;
/**
 *
 * @author dannycoward
 */
public abstract class WebSocketEndpoint extends WebSocketApplication {
    protected String path;
    protected String remoteImplClassname = WebSocketWrapper.class.getCanonicalName();
    protected EndpointContextImpl webSocketContext;
    //uck, but there isn't a better integration point yet with Grizzy
    protected HttpSession httpSessionForNextOnConnect = null; 
    private String originAddressForNextOnConnect = null;
    protected List supportedSubprotocols = new ArrayList();
    
    public WebSocketEndpoint() {
        this.webSocketContext = new EndpointContextImpl(BeanServer.getContainerContext(), this);
    }
    
    String getPath() {
        return this.path;
    }
    
    EndpointContextImpl getWebSocketContext() {
        return this.webSocketContext;
    }
    
    String getRemoteImplClassname() {
        return this.remoteImplClassname;
    }
    
    @Override
    public boolean isApplicationRequest(org.glassfish.grizzly.http.HttpRequestPacket o) {
        //System.out.print("Checking WSApp path=" + path + " matches ? " + o.requestURI());
        // TODO need separate logic to take servlet context path
        boolean match = o.getRequestURI().endsWith(path);
        //System.out.println(":" + match);
        //this.dump(o , System.out);


        //httpSessionForNextOnConnect = this.getHttpSession(o);
        this.originAddressForNextOnConnect = o.getHeader("Origin");
        return match;
    }
   
    // I don't really know what Grizzly does with this for sure, but
    // I'm going to guess that it wants a sublist of all the supplied
    // subprotocol names that this application will support...
    public List<String> getSupportedProtocols(List<String> subProtocol) {
        List<String> supported = new ArrayList<String>();
        for (String nextRequestedProtocolName : subProtocol) {
            if (this.supportedSubprotocols.contains(nextRequestedProtocolName)) {
                supported.add(nextRequestedProtocolName); 
            }
        }
        //System.out.println("Requested protocols = " + subProtocol);
        //System.out.println("Supported protocols = " + supported);
        return supported;
    }
    
    // called by the wrapper based on the subprotocols listed in the class annotation
    protected void addSupportedSubprotocol(String subprotocol) {
        supportedSubprotocols.add(subprotocol);
    }
    
    public void onConnect(WebSocket socket) {
        WebSocketWrapper wsw = WebSocketWrapper.getWebSocketWrapper(socket, this);
        if (wsw == null) {
            throw new RuntimeException("XCouldn't find web socket wrapper for this socket for "+ this.remoteImplClassname);
        }
        wsw.setAddress(this.originAddressForNextOnConnect);
//        if (ContainerContextImpl.WEB_MODE) {
//            if (httpSessionForNextOnConnect != null) {
//                ((WebSocketConversationImpl) wsw.getConversation()).setHttpSession(httpSessionForNextOnConnect);
//                httpSessionForNextOnConnect = null;
//            } else {
//                throw new RuntimeException("Failed to connect the http session with this web socket session");
//            }
//
//        } else {
//
//        }
    }

    public void onClose(WebSocket socket) {
        throw new RuntimeException("I got closed...");
    }  
    
    
    /*
    
    public HttpSession getHttpSession(HttpRequestPacket o) {
        Cookies cookies = o.getCookies();
        int count = cookies.getCookieCount();
        //System.out.println("There are : " + count + " cookies on the ws request.");
        for (int i = 0; i < count; i++) {
            ServerCookie sc = cookies.getCookie(i);
            //System.out.println("---" + sc.getValue());
            String potentialSessionID = sc.getValue().toString();
            HttpSession session = HttpSessionManager.getInstance().findSessionByID(potentialSessionID);
            if (session != null) {
                //System.out.println("got " + session);
                return session;
            }
        }
        return null;
    }
        
        
    public void dump(HttpRequestPacket o, PrintStream os) {
        os.println("decoded URI: " + o.decodedURI());
        os.println("request URI: " + o.requestURI());
        os.println("auth type: " + o.getAuthType());
        os.println("auth type: " + o.getAuthType());
        os.println("cookies: " + o.getCookies());
        os.println("request processor: " + o.getRequestProcessor());
        os.println("origin processor: " + o.getHeader("Origin"));
        os.println("client address: " + o.getLocalAddress());
        
    }
    */
    
    public void remove() {
        
    }
    

}
