/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.glassfish.websockets.platform;

import org.glassfish.websockets.api.WSEndpoint;

import org.glassfish.grizzly.websockets.*;
/**
 *
 * @author dannycoward
 */
public class WebSocketEndpointAdapter extends WebSocketEndpoint {
    private WSEndpoint endpoint;
    
    
    
    WebSocketEndpointAdapter(WSEndpoint endpoint, String path) {
        this.endpoint = endpoint;
        super.path = path;
    }
    
    void init() {
        this.endpoint.initialize(super.getWebSocketContext());
    }
    
    public void onConnect(WebSocket socket) {
        super.onConnect(socket);
        WebSocketWrapper wsw = WebSocketWrapper.getWebSocketWrapper(socket, this);
        this.endpoint.onOpen(wsw);
    }
    
    public void onMessage(WebSocket socket, String messageString) { 
        WebSocketWrapper wsw = WebSocketWrapper.getWebSocketWrapper(socket, this);
        this.endpoint.onMessage(wsw, messageString);  
    }
    
    public void onMessage(WebSocket socket, byte[] data) { 
        WebSocketWrapper wsw = WebSocketWrapper.getWebSocketWrapper(socket, this);
        this.endpoint.onMessage(wsw, data);  
    }
    
    public void onClose(WebSocket socket) {
        super.onClose(socket);
        WebSocketWrapper wsw = WebSocketWrapper.getWebSocketWrapper(socket, this);
        this.endpoint.onClose(wsw, null); // TODO
    }
    
    public void remove() {
        this.endpoint.remove();
    }
    
}
