/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package org.glassfish.websockets.platform.processors;

import java.io.IOException;
import java.io.PrintWriter;
import javax.lang.model.element.Element;
import javax.lang.model.element.ExecutableElement;
import javax.lang.model.element.VariableElement;
import org.glassfish.websockets.api.annotations.WebSocketRemote;
import java.util.*;

/**
 *
 * @author dannycoward
 */
public class RemoteClassWriter {
    
    static void writePackageAndImports(PrintWriter pw, String packageName) throws IOException {
        pw.println("package " + packageName + ";");
        pw.println();
        pw.println("import org.glassfish.grizzly.websockets.WebSocket;");
        pw.println("import org.glassfish.websockets.platform.*;");
        pw.println("import org.glassfish.websockets.api.ConversionException;");
        pw.println("import java.util.*;");
        pw.println("import java.io.*;");
        pw.println();
    }
    
    static void writeClassDeclaration(PrintWriter pw, String interfaceName, String classname, List<Element> methods) {
        pw.println("public class " + classname + " extends WebSocketWrapper implements "+interfaceName+" {");
        pw.println();
        //pw.println("\tpublic " + classname + "(WebSocket socket) {");
        //pw.println("\t\tsuper(socket);");
        //pw.println("\t}");
        writeSendMethodImplementations(pw, methods);
        pw.println("}");
    }
    
    static void writeSendMethodImplementations(PrintWriter pw, List<Element> methods) {
        for (Element method : methods) {
            String methodName = method.getSimpleName().toString();
            WebSocketRemote wsr = method.getAnnotation(WebSocketRemote.class);
            ExecutableElement eMethod = (ExecutableElement) method;
            VariableElement ve = eMethod.getParameters().get(0);
                // FIXIT check shape of the method here...
                // eMethod.getParameters() size = 1
            String parameterClassname = ve.asType().toString();
            String parameterName = ve.getSimpleName().toString();
            pw.println("\tpublic void " + methodName + "(" + parameterClassname + " " + parameterName + ") throws IOException, ConversionException {");

             // convert into a string
             // invoke socket
            pw.println("\t\tsuper.doNothing();");
             // for now
            if ("".equals(wsr.encoder())) {
                if (parameterClassname.equals("java.lang.String")) {
                    pw.println("\t\tString messageAsString = " + parameterName + ";");
                } else if (parameterClassname.equals("int") ||
                        parameterClassname.equals("byte") ||
                        parameterClassname.equals("short") ||
                        parameterClassname.equals("long") ||
                        parameterClassname.equals("float") ||
                        parameterClassname.equals("double") ||
                        parameterClassname.equals("boolean") ||
                        parameterClassname.equals("char")) {
                    pw.println("\t\tObject messageAsObject = "+parameterName+";");
                    pw.println("\t\tString messageAsString = messageAsObject.toString();");
                    //pw.println(parameterClassname);
                } else {
                    throw new RuntimeException("Unknown parameter type is custom client");
                }

            } else {
                String encoderClassname = wsr.encoder();
                pw.println("\t\t"+encoderClassname+" encoder = new "+encoderClassname+"();");
                pw.println("\t\tString messageAsString = encoder.encode(" + parameterName + ");");
            }
            pw.println("\t\tsuper.sendMessage(messageAsString);"); 
            pw.println();


             pw.println("\t}");
        }
        pw.println();
         
    }
}
