package org.glassfish.websockets.platform.web;

import javax.servlet.*;
import javax.servlet.annotation.WebListener; 
import java.net.*;
import java.io.*;
import java.util.*;
import org.glassfish.websockets.platform.BeanServer;
import java.util.logging.*;

import java.util.*;
/**
 * Web application lifecycle listener.
 * @author dannycoward
 */
@WebListener()
public class WebSocketServerWebIntegration implements ServletContextListener {
    static final String ENDPOINT_CLASS_SET = "org.glassfish.websockets.platform.web.endpoint.class.set";

    private static final String websocketroot = "/websockets";
    public static final String PRINCIPAL = "ws_principal";
    private static final int informational_fixed_port = 8080;
    
    private BeanServer bs = null;
    
    @Override
    public void contextInitialized(ServletContextEvent sce) {
        Set<Class<?>> endpointClassSet = (Set<Class<?>>)sce.getServletContext().getAttribute(ENDPOINT_CLASS_SET);
        if (endpointClassSet == null || endpointClassSet.isEmpty()) {
            return;
        }
        bs = new BeanServer();
        try {
            bs.initWebSocketServer(this.websocketroot, informational_fixed_port, endpointClassSet);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void contextDestroyed(ServletContextEvent sce) {
        bs.closeWebSocketServer();
    }

}